//-----------------------------------------------------//
//                                                     //
//            Code generated by RT/shader              //
//            at: 2/25/2005 2:12:18 PM                 //
//                                                     //
//-----------------------------------------------------//


// Structures
struct Technique1_Pass1_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
};

struct Technique1_Pass1_PS_OUT 
{
	float4 color : COLOR0;
};

struct Technique1_Pass2_VS_OUT 
{
	float4 position : POSITION;
	float2 uv0 : TEXCOORD0;
	float falloff1 : TEXCOORD1;
	float3 reflectVector : TEXCOORD2;
};

struct Technique1_Pass2_PS_OUT 
{
	float4 color : COLOR0;
};


// Uniform Parameters
float4x4 projTM : WorldViewProjection;
texture Texture
<
	string name = "C:\\Program Files\\RTzen\\RTshader\\media\\images\\H-6\\h6_main.dds";
	string UIName = "Texture";

>;
float4x4 worldTM : World;
float4 eyePos : WorldEyePosition;
float4x4 worldITTM : WorldIT;
texture Reflection
<
	string name = "clouds.dds";
	string type = "CUBE";
	string UIName = "Reflection";

>;
texture Texture2
<
	string name = "C:\\Program Files\\RTzen\\RTshader\\media\\images\\H-6\\h6_main.dds";
	string UIName = "Texture2";

>;
float Brushed_Metal_Amount
<
	string UIType = "MaxSpinner";
	string UIName = "Brushed Metal Amount";

> = 5;

// Samplers
sampler2D TextureSampler = sampler_state
{
	Texture = <Texture>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

samplerCUBE ReflectionSampler = sampler_state
{
	Texture = <Reflection>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

sampler2D Texture2Sampler = sampler_state
{
	Texture = <Texture2>;
	AddressU = Wrap;
	AddressV = Wrap;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};


// Functions
float Falloff(
		float4 surface,
		float4 eye,
		float3 norm,
		float amount)
{
	float3 eyeVect = normalize(eye.xyz-surface.xyz);
	float falloff = 1-dot(eyeVect, norm);
	return pow(falloff, amount);
}

Technique1_Pass1_VS_OUT Technique1_Pass1_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		uniform float4x4 projTM)
{
	Technique1_Pass1_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	return OUT;
}

Technique1_Pass1_PS_OUT Technique1_Pass1_PS(
		float2 uv0 : TEXCOORD0,
		uniform sampler2D TextureSampler)
{
	Technique1_Pass1_PS_OUT OUT;
	OUT.color = tex2D(TextureSampler, uv0.xy);
	return OUT;
}

Technique1_Pass2_VS_OUT Technique1_Pass2_VS(
		float3 pos : POSITION,
		float2 uv0 : TEXCOORD0,
		float3 norm : NORMAL,
		uniform float4x4 projTM,
		uniform float4x4 worldTM,
		uniform float4 eyePos,
		uniform float4x4 worldITTM)
{
	Technique1_Pass2_VS_OUT OUT;
	OUT.position = mul(float4(pos.xyz, 1), projTM);
	OUT.uv0 = uv0;
	float4 surface1 = mul(float4(pos.xyz, 1), worldTM);
	float3 norm1 = normalize(mul(norm, (float3x3)worldITTM));
	OUT.falloff1 = Falloff(surface1, eyePos, norm1, 1);
	OUT.reflectVector = reflect(normalize(surface1-eyePos), norm1).xyz;
	return OUT;
}

Technique1_Pass2_PS_OUT Technique1_Pass2_PS(
		float3 reflectVector : TEXCOORD2,
		float falloff1 : TEXCOORD1,
		float2 uv0 : TEXCOORD0,
		uniform samplerCUBE ReflectionSampler,
		uniform sampler2D Texture2Sampler,
		uniform float Brushed_Metal_Amount)
{
	Technique1_Pass2_PS_OUT OUT;
	float4 a1 = texCUBE(ReflectionSampler, reflectVector.xyz);
	float4 a2 = a1*falloff1;
	float4 vect1 = tex2D(Texture2Sampler, uv0.xy);
	float a3 = ((vect1.x+vect1.y)+vect1.z)/3;
	float a4 = a3-0.5;
	float a5 = a4*1.20000004768372;
	float a6 = a5+0.5;
	float b1 = a6*Brushed_Metal_Amount;
	OUT.color = a2*b1;
	return OUT;
}


// Techniques
technique Technique1
{
	pass Pass1
	{
		VertexShader = compile vs_3_0 Technique1_Pass1_VS(projTM);
		PixelShader = compile ps_3_0 Technique1_Pass1_PS(TextureSampler);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = false;
	}
	pass Pass2
	{
		VertexShader = compile vs_3_0 Technique1_Pass2_VS(projTM, worldTM, eyePos, worldITTM);
		PixelShader = compile ps_3_0 Technique1_Pass2_PS(ReflectionSampler, Texture2Sampler, Brushed_Metal_Amount);
		ZEnable = true;
		ZWriteEnable = true;
		CullMode = CW;
		AlphaBlendEnable = true;
		SrcBlend = ONE;
		DestBlend = ONE;
	}
}

